package com.its.api.its.service.oper;

import com.its.api.its.model.dto.oper.TbUserInfrDto;
import com.its.api.its.model.entity.oper.TbUserInfr;
import com.its.api.its.repository.oper.TbUserInfrRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbUserInfrService {

    private final TbUserInfrRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbUserInfr requireOne(String id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbUserInfrDto> findAll() {
        List<TbUserInfrDto> result = new ArrayList<>();
        List<TbUserInfr> data = this.repo.findAll();
        for (TbUserInfr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbUserInfrDto findById(String id) {
        TbUserInfr entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbUserInfrDto updateById(String id, TbUserInfrDto.TbUserInfrUpdReq req) {
        TbUserInfr entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbUserInfrDto> mergeInfoList(List<TbUserInfrDto.TbUserInfrUpdReq> reqList) {
        List<TbUserInfrDto> result = new ArrayList<>();
        for (TbUserInfrDto.TbUserInfrUpdReq req : reqList) {
            TbUserInfr obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbUserInfrDto mergeInfo(String id, TbUserInfrDto.TbUserInfrUpdReq req) {
        TbUserInfr obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbUserInfrDto deleteById(String id) {
        TbUserInfr entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbUserInfrDto> deleteByIds(List<String> ids) {
        List<TbUserInfrDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbUserInfr> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    // 운영자 비밀번호 변경
    @Transactional
    public TbUserInfrDto updatePswdById(String id, TbUserInfrDto.TbUserPswdUpdReq req) {

        TbUserInfr entity = requireOne(id);
        if (!entity.getPwd().equals(req.getOldPwd())) {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
        if (entity.getPwd().equals(req.getPwd())) {
            throw new NoSuchElementException("현재 비빌번호와 같습니다: " + id);
        }
        entity.updatePswd(req);
        this.repo.save(entity);
        return entity.toDto();
    }
}
